/**
   \file audiofs.c Audio Filesystem driver for VsOS
   \author Henrik Herranen, VLSI Solution Oy
*/

#include <vo_stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <vstypes.h>
#include <vs1005h.h>
#include <timers.h>
#include <vsos.h>
#include <sysmemory.h>
#include <ringbuf.h>
#include <imem.h>
#include "auopwm.h"
#include "sigmadelta8.h"
#include "interleave.h"

#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))

void PwmInterruptVector(void);
extern u_int32 auxi;
u_int16 useSigmaDelta;

struct AudioOut audioOut = {
  NULL
};

struct SigmaDelta8 sigmaDelta8;

auto u_int16 AudioOutFree(void) {
  s_int16 fi = audioOut.wr - audioOut.rd;
  s_int16 fr;
  if (fi < 0)
    fi += audioOut.bufSize;
  fr = audioOut.bufSize - fi - 1;
  if (fr < 0)
    return 0;
  return fr & ~3;
}





ioresult AudioClose(void) {
  PERIP(INT_ENABLE1_HP) &= ~INTF1_PWM;

  if (audioOut.bufSize) {
    FreeMemY(audioOut.buf, audioOut.bufSize);
    audioOut.bufSize = NULL;
  }
}


ioresult AllocateAudioBuffer(register struct AudioOut *a,
			     register u_int16 bufSize) {
  ioresult res = S_OK;
  Disable();
  if (a->bufSize) {
    FreeMemY(a->buf, a->bufSize);
  }

  bufSize &= ~3;
  if (!(a->buf = AllocMemY(bufSize, CeilPow2(bufSize)))) {
    static __align u_int16 __mem_y panicBuffer[4];
    a->buf = panicBuffer;
    a->bufSize = 0;
    a->modifier = MAKEMODF(4);
    res = S_ERROR;
  } else {
    memsetY(a->buf, 0, bufSize);
    a->bufSize = bufSize;
    a->modifier = MAKEMODF(bufSize);
  }
  a->wr = a->rd = (__mem_y s_int16 *)(a->buf);
  Enable();
  return res;
}

IOCTL_RESULT AudioIoctl(register __i0 VO_FILE *self, s_int16 request,
			IOCTL_ARGUMENT argp) {
  ioresult res = S_OK;

#if 0
  fprintf(stderr, "Ioctl(%p, %d, %p)\n", self, request, argp);
#endif

  switch (request) {
#if 0
  case IOCTL_START_FRAME:			
    break;
		
  case IOCTL_END_FRAME:
    break;
#endif

  case IOCTL_RESTART:
    PERIP(PWM_FRAMELEN) = 0;
    PERIP(INT_ENABLE1_LP) &= ~INTF1_PWM;
    PERIP(INT_ENABLE1_HP) &= ~INTF1_PWM;
    WriteIMem(0x20 + INTV_PWM, ReadIMem((u_int16)PwmInterruptVector));  
    if (AllocateAudioBuffer(&audioOut, 512)) {
      res = S_ERROR;
    }
    InitSigmaDelta8(&sigmaDelta8);
    audioOut.flags &= ~AIN_32BIT;
    PERIP(PWM_FRAMELEN) = 255;
    break;

  case IOCTL_AUDIO_GET_ORATE:
    *((u_int32 *)argp) = 48000;
    break;

  case IOCTL_AUDIO_SET_ORATE:
    res = -1;
    break;

  case IOCTL_AUDIO_SET_RATE_AND_BITS:
    res = -1;
    break;

  case IOCTL_AUDIO_GET_BITS:
    return (audioOut.flags & (AIN_32BIT)) ? 32 : 16;
    break;

  case IOCTL_AUDIO_SET_BITS:
    Disable();
    if ((u_int16)argp > 16) {
      audioOut.flags |= AIN_32BIT;
    } else {
      audioOut.flags &= ~AIN_32BIT;
    }
    audioOut.wr = audioOut.rd = (__mem_y s_int16 *)(audioOut.buf);
    Enable();
    break;

  case IOCTL_AUDIO_GET_OUTPUT_BUFFER_SIZE:
    return audioOut.bufSize;
    break;

  case IOCTL_AUDIO_SET_OUTPUT_BUFFER_SIZE:
    if (AllocateAudioBuffer(&audioOut, (u_int16)argp)) {
      res = S_ERROR;
    }
    break;

  case IOCTL_AUDIO_GET_OUTPUT_BUFFER_FREE:
    return AudioOutFree();
    break;

  case IOCTL_AUDIO_GET_SAMPLE_COUNTER:
    Disable();
    *((u_int32 *)argp) = audioOut.sampleCounter;
    Enable();
    break;

  case IOCTL_AUDIO_GET_UNDERFLOWS:
    Disable();
    *((u_int32 *)argp) = audioOut.underflow;
    Enable();
    break;

  default:
    res = S_ERROR;
    break;
  }

  if (audioOut.bufSize) {
    audioFile.flags = __MASK_PRESENT | __MASK_OPEN | __MASK_CHARACTER_DEVICE |
      __MASK_FILE |
      __MASK_READABLE | __MASK_WRITABLE;
    PERIP(INT_ENABLE1_HP) |= INTF1_PWM;
  } else {
    audioFile.flags = __MASK_PRESENT | __MASK_OPEN | __MASK_CHARACTER_DEVICE |
      __MASK_FILE;
    PERIP(INT_ENABLE1_HP) &= ~INTF1_PWM;
  }

  return res;
}



u_int16 AudioWrite(register __i0 VO_FILE *self, u_int16 *buf,
		   u_int16 sourceIndex, u_int16 bytes) {
  u_int16 left = bytes>>1;
  if (sourceIndex || (bytes&((audioOut.flags & AIN_32BIT) ? 7 : 3))) {
    return 0;
  }

  /* In-place operation is naughty, but we do up to 3 of them. */

  /* Compress 32-bit audio to 16 bits */
  if (audioOut.flags & AIN_32BIT) {
    left >>= 1;
    ringcpyXX(buf, 1, buf, 2, left);
  }

  /* Convert stereo to mono */
  left >>= 1;
  InterleavedStereoToMono((s_int16 *)buf, (s_int16 *)buf, left);

  /* Run the sigma-delta modulator to the mono signal. */
  if (useSigmaDelta) {
    RunSigmaDelta8(&sigmaDelta8, (s_int16 *)buf, left);
  } else {
    int i;
    s_int16 *p = (s_int16 *)buf;
    for (i=0; i<left; i++) {
      *p = (*p >> 8) + 128;
      p++;
    }
  }

  while (left) {
    u_int16 toWrite = MIN(left, 16);
    while (AudioOutFree() < toWrite) {
      Delay(1);
    }
    audioOut.wr =
      RING_XY_D(ringcpyXY(audioOut.wr, audioOut.modifier, buf, 1, toWrite));
    buf += toWrite;
    left -= toWrite;
  }
  return bytes;
}

char *Identify(register __i0 void *self, char *buf, u_int16 bufSize) {
  strncpy(buf, "AUOPWM", bufSize);
  buf[bufSize-1] = '\0';
  return buf;
}

FILEOPS audioFileOps = {
  NULL, /* Open() */
  NULL, /* Close() */
  AudioIoctl, /* Ioctl() */
  CommonOkResultFunction, /* Read() */
  AudioWrite /* Write() */
};

SIMPLE_FILE audioFile = {
  __MASK_PRESENT|__MASK_OPEN|__MASK_WRITABLE|__MASK_READABLE|__MASK_FILE, /* Flags */
  Identify, /* Identify() */
  &audioFileOps,
  0, /* pos */
  0, /* ungetc_buffer */
  NULL, /* dev */
};
